//
// DO NOT EDIT.
//
// Generated by the protocol buffer compiler.
// Source: evmos/inflation/v1/query.proto
//

//
// Copyright 2018, gRPC Authors All rights reserved.
//
// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at
//
//     http://www.apache.org/licenses/LICENSE-2.0
//
// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
//
import GRPC
import NIO
import SwiftProtobuf


/// Query provides defines the gRPC querier service.
///
/// Usage: instantiate `Evmos_Inflation_V1_QueryClient`, then call methods of this protocol to make API calls.
internal protocol Evmos_Inflation_V1_QueryClientProtocol: GRPCClient {
  var serviceName: String { get }
  var interceptors: Evmos_Inflation_V1_QueryClientInterceptorFactoryProtocol? { get }

  func period(
    _ request: Evmos_Inflation_V1_QueryPeriodRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Evmos_Inflation_V1_QueryPeriodRequest, Evmos_Inflation_V1_QueryPeriodResponse>

  func epochMintProvision(
    _ request: Evmos_Inflation_V1_QueryEpochMintProvisionRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Evmos_Inflation_V1_QueryEpochMintProvisionRequest, Evmos_Inflation_V1_QueryEpochMintProvisionResponse>

  func params(
    _ request: Evmos_Inflation_V1_QueryParamsRequest,
    callOptions: CallOptions?
  ) -> UnaryCall<Evmos_Inflation_V1_QueryParamsRequest, Evmos_Inflation_V1_QueryParamsResponse>
}

extension Evmos_Inflation_V1_QueryClientProtocol {
  internal var serviceName: String {
    return "evmos.inflation.v1.Query"
  }

  /// Period retrieves current period.
  ///
  /// - Parameters:
  ///   - request: Request to send to Period.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func period(
    _ request: Evmos_Inflation_V1_QueryPeriodRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Evmos_Inflation_V1_QueryPeriodRequest, Evmos_Inflation_V1_QueryPeriodResponse> {
    return self.makeUnaryCall(
      path: "/evmos.inflation.v1.Query/Period",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makePeriodInterceptors() ?? []
    )
  }

  /// EpochMintProvision retrieves current minting epoch provision value.
  ///
  /// - Parameters:
  ///   - request: Request to send to EpochMintProvision.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func epochMintProvision(
    _ request: Evmos_Inflation_V1_QueryEpochMintProvisionRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Evmos_Inflation_V1_QueryEpochMintProvisionRequest, Evmos_Inflation_V1_QueryEpochMintProvisionResponse> {
    return self.makeUnaryCall(
      path: "/evmos.inflation.v1.Query/EpochMintProvision",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeEpochMintProvisionInterceptors() ?? []
    )
  }

  /// Params retrieves the total set of minting parameters.
  ///
  /// - Parameters:
  ///   - request: Request to send to Params.
  ///   - callOptions: Call options.
  /// - Returns: A `UnaryCall` with futures for the metadata, status and response.
  internal func params(
    _ request: Evmos_Inflation_V1_QueryParamsRequest,
    callOptions: CallOptions? = nil
  ) -> UnaryCall<Evmos_Inflation_V1_QueryParamsRequest, Evmos_Inflation_V1_QueryParamsResponse> {
    return self.makeUnaryCall(
      path: "/evmos.inflation.v1.Query/Params",
      request: request,
      callOptions: callOptions ?? self.defaultCallOptions,
      interceptors: self.interceptors?.makeParamsInterceptors() ?? []
    )
  }
}

internal protocol Evmos_Inflation_V1_QueryClientInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when invoking 'period'.
  func makePeriodInterceptors() -> [ClientInterceptor<Evmos_Inflation_V1_QueryPeriodRequest, Evmos_Inflation_V1_QueryPeriodResponse>]

  /// - Returns: Interceptors to use when invoking 'epochMintProvision'.
  func makeEpochMintProvisionInterceptors() -> [ClientInterceptor<Evmos_Inflation_V1_QueryEpochMintProvisionRequest, Evmos_Inflation_V1_QueryEpochMintProvisionResponse>]

  /// - Returns: Interceptors to use when invoking 'params'.
  func makeParamsInterceptors() -> [ClientInterceptor<Evmos_Inflation_V1_QueryParamsRequest, Evmos_Inflation_V1_QueryParamsResponse>]
}

internal final class Evmos_Inflation_V1_QueryClient: Evmos_Inflation_V1_QueryClientProtocol {
  internal let channel: GRPCChannel
  internal var defaultCallOptions: CallOptions
  internal var interceptors: Evmos_Inflation_V1_QueryClientInterceptorFactoryProtocol?

  /// Creates a client for the evmos.inflation.v1.Query service.
  ///
  /// - Parameters:
  ///   - channel: `GRPCChannel` to the service host.
  ///   - defaultCallOptions: Options to use for each service call if the user doesn't provide them.
  ///   - interceptors: A factory providing interceptors for each RPC.
  internal init(
    channel: GRPCChannel,
    defaultCallOptions: CallOptions = CallOptions(),
    interceptors: Evmos_Inflation_V1_QueryClientInterceptorFactoryProtocol? = nil
  ) {
    self.channel = channel
    self.defaultCallOptions = defaultCallOptions
    self.interceptors = interceptors
  }
}

/// Query provides defines the gRPC querier service.
///
/// To build a server, implement a class that conforms to this protocol.
internal protocol Evmos_Inflation_V1_QueryProvider: CallHandlerProvider {
  var interceptors: Evmos_Inflation_V1_QueryServerInterceptorFactoryProtocol? { get }

  /// Period retrieves current period.
  func period(request: Evmos_Inflation_V1_QueryPeriodRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Evmos_Inflation_V1_QueryPeriodResponse>

  /// EpochMintProvision retrieves current minting epoch provision value.
  func epochMintProvision(request: Evmos_Inflation_V1_QueryEpochMintProvisionRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Evmos_Inflation_V1_QueryEpochMintProvisionResponse>

  /// Params retrieves the total set of minting parameters.
  func params(request: Evmos_Inflation_V1_QueryParamsRequest, context: StatusOnlyCallContext) -> EventLoopFuture<Evmos_Inflation_V1_QueryParamsResponse>
}

extension Evmos_Inflation_V1_QueryProvider {
  internal var serviceName: Substring { return "evmos.inflation.v1.Query" }

  /// Determines, calls and returns the appropriate request handler, depending on the request's method.
  /// Returns nil for methods not handled by this service.
  internal func handle(
    method name: Substring,
    context: CallHandlerContext
  ) -> GRPCServerHandlerProtocol? {
    switch name {
    case "Period":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Evmos_Inflation_V1_QueryPeriodRequest>(),
        responseSerializer: ProtobufSerializer<Evmos_Inflation_V1_QueryPeriodResponse>(),
        interceptors: self.interceptors?.makePeriodInterceptors() ?? [],
        userFunction: self.period(request:context:)
      )

    case "EpochMintProvision":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Evmos_Inflation_V1_QueryEpochMintProvisionRequest>(),
        responseSerializer: ProtobufSerializer<Evmos_Inflation_V1_QueryEpochMintProvisionResponse>(),
        interceptors: self.interceptors?.makeEpochMintProvisionInterceptors() ?? [],
        userFunction: self.epochMintProvision(request:context:)
      )

    case "Params":
      return UnaryServerHandler(
        context: context,
        requestDeserializer: ProtobufDeserializer<Evmos_Inflation_V1_QueryParamsRequest>(),
        responseSerializer: ProtobufSerializer<Evmos_Inflation_V1_QueryParamsResponse>(),
        interceptors: self.interceptors?.makeParamsInterceptors() ?? [],
        userFunction: self.params(request:context:)
      )

    default:
      return nil
    }
  }
}

internal protocol Evmos_Inflation_V1_QueryServerInterceptorFactoryProtocol {

  /// - Returns: Interceptors to use when handling 'period'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makePeriodInterceptors() -> [ServerInterceptor<Evmos_Inflation_V1_QueryPeriodRequest, Evmos_Inflation_V1_QueryPeriodResponse>]

  /// - Returns: Interceptors to use when handling 'epochMintProvision'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeEpochMintProvisionInterceptors() -> [ServerInterceptor<Evmos_Inflation_V1_QueryEpochMintProvisionRequest, Evmos_Inflation_V1_QueryEpochMintProvisionResponse>]

  /// - Returns: Interceptors to use when handling 'params'.
  ///   Defaults to calling `self.makeInterceptors()`.
  func makeParamsInterceptors() -> [ServerInterceptor<Evmos_Inflation_V1_QueryParamsRequest, Evmos_Inflation_V1_QueryParamsResponse>]
}
